function [fitresult, gof] = createFit(x, y)
%CREATEFIT(X,Y)
%  Create a fit.
%
%  Data for 'untitled fit 1' fit:
%      X Input : x
%      Y Output: y
%  Output:
%      fitresult : a fit object representing the fit.
%      gof : structure with goodness-of fit info.
%
%  See also FIT, CFIT, SFIT.

%  Auto-generated by MATLAB on 04-Jun-2015 14:51:30


%% Fit: 'untitled fit 1'.
[xData, yData] = prepareCurveData( x, y );

% Set up fittype and options.
ft = fittype( 'A0 + A1*sin((2*pi*x)/48 +phi1) + A2*sin((2*pi*x)/24+ phi2) + A3*sin((2*pi*x)/12+ phi3) +A4*sin((2*pi*x)/8+ phi4)', 'independent', 'x', 'dependent', 'y' );
opts = fitoptions( ft );
opts.Display = 'Off';
opts.Lower = [0 -Inf -inf -Inf -Inf 0 0 0 0 ];
opts.StartPoint = [0.737858095516997 0.269119426398556 0.422835615008808 0.547870901214845 0.942736984276934 0.417744104316662 0.983052466469856 0.301454948712065 0.701098755900926];
opts.Upper = [Inf Inf Inf Inf Inf 2*pi 2*pi 2*pi 2*pi];
opts.Algorithm = 'Trust-Region';
% Fit model to data.
[fitresult, gof] = fit( xData, yData, ft, opts );

% % Plot fit with data.
% figure( 'Name', 'untitled fit 1' );
% h = plot( fitresult, xData, yData );
% legend( h, 'y vs. x', 'untitled fit 1', 'Location', 'NorthEast' );
% % Label axes
% xlabel( 'x' );
% ylabel( 'y' );
% grid on


