%--------------------------------------------------------------------------
% This script takes in four sets of satellite data and calculates daily
% mean Medium Energetic (particle) Precipiration (MEP)
%--------------------------------------------------------------------------
%--------------------------------------------------------------------------
% Satellite 1
%--------------------------------------------------------------------------
file ='LossConeEnergyDeposition_south2008_1-366_N16_1MeV_1.04step_Filter300.nc';
doy = ncread(file, 'DOY'); %date of year
glat = ncread(file, 'Geographic latitude'); 
glong = ncread(file, 'Geographic longitude'); 
mlt = ncread(file,'Magnetic local time'); 
cgmlat = ncread(file,'Corrected geomagnetic latitude'); 

energy60km = ncread(file, 'Energy deposition at 60 km');
  energy61km = ncread(file, 'Energy deposition at 61 km');
  energy62km = ncread(file, 'Energy deposition at 62 km');
  energy63km = ncread(file, 'Energy deposition at 63 km');
  energy64km = ncread(file, 'Energy deposition at 64 km');
  energy65km = ncread(file, 'Energy deposition at 65 km');
  energy66km = ncread(file, 'Energy deposition at 66 km');
  energy67km = ncread(file, 'Energy deposition at 67 km');
  energy68km = ncread(file, 'Energy deposition at 68 km');
  energy69km = ncread(file, 'Energy deposition at 69 km'); 
  energy70km = ncread(file, 'Energy deposition at 70 km');
  energy71km = ncread(file, 'Energy deposition at 71 km');
  energy72km = ncread(file, 'Energy deposition at 72 km');
  energy73km = ncread(file, 'Energy deposition at 73 km');
  energy74km = ncread(file, 'Energy deposition at 74 km');
  energy75km = ncread(file, 'Energy deposition at 75 km');
  energy76km = ncread(file, 'Energy deposition at 76 km');
  energy77km = ncread(file, 'Energy deposition at 77 km');
  energy78km = ncread(file, 'Energy deposition at 78 km');
  energy79km = ncread(file, 'Energy deposition at 79 km'); 
  energy80km = ncread(file, 'Energy deposition at 80 km');
   
datamatrix = [doy glat glong mlt cgmlat energy60km energy61km energy62km...
              energy63km energy64km energy65km energy66km energy67km...
              energy68km energy69km energy70km energy71km energy72km...
              energy73km energy74km energy75km energy76km energy77km...
              energy78km energy79km energy80km];
%--------------------------------------------------------------------------
% Unit: energy[km] = keV / cm^3 s
% Unit: totalenergy = keV/ cm^2 s
% Unit: time = seconds
% Unit: height = km
%--------------------------------------------------------------------------
% Sum over all heights, dz=1km = 1000m = 100000cm 
% Unit was keV/cm^3, sums over the column from 60 to 80 km
%--------------------------------------------------------------------------
totalenergy=zeros(length(doy),1);
for i=1:length(doy)
    totalenergy(i) = sum(datamatrix(i,6:26))*100000;
end
%Unit is now keV/cm^2

Datamatrix = [doy glat glong mlt cgmlat totalenergy];

%--------------------------------------------------------------------------
% Coordinates for Troll: lat=-72.0019 long=2.5339, box = +/- 5 deg
%--------------------------------------------------------------------------
for i=1:length(doy)
if glong(i)<7.5339 || glong(i)>357.5339
    Datamatrix(i,:)=Datamatrix(i,:);
else
    Datamatrix(i,:)=NaN;
end
end
for i=1:length(doy)
if  glat(i)>-77.0019 && glat(i)<-67.0019
    Datamatrix(i,:)=Datamatrix(i,:);
else 
    Datamatrix(i,:)=NaN;
end
end
% Remove all entries except those within designated glong and glat and store
Data1=Datamatrix(~isnan(Datamatrix(:,1)),:);

%--------------------------------------------------------------------------
% Satellite 2
%--------------------------------------------------------------------------
file='LossConeEnergyDeposition_south2008_1-366_N17_1MeV_1.04step_Filter300.nc';

doy = ncread(file, 'DOY'); %date of year
glat = ncread(file, 'Geographic latitude'); 
glong = ncread(file, 'Geographic longitude'); 
mlt = ncread(file,'Magnetic local time'); 
cgmlat = ncread(file,'Corrected geomagnetic latitude'); 

energy60km = ncread(file, 'Energy deposition at 60 km');
  energy61km = ncread(file, 'Energy deposition at 61 km');
  energy62km = ncread(file, 'Energy deposition at 62 km');
  energy63km = ncread(file, 'Energy deposition at 63 km');
  energy64km = ncread(file, 'Energy deposition at 64 km');
  energy65km = ncread(file, 'Energy deposition at 65 km');
  energy66km = ncread(file, 'Energy deposition at 66 km');
  energy67km = ncread(file, 'Energy deposition at 67 km');
  energy68km = ncread(file, 'Energy deposition at 68 km');
  energy69km = ncread(file, 'Energy deposition at 69 km'); 
  energy70km = ncread(file, 'Energy deposition at 70 km');
  energy71km = ncread(file, 'Energy deposition at 71 km');
  energy72km = ncread(file, 'Energy deposition at 72 km');
  energy73km = ncread(file, 'Energy deposition at 73 km');
  energy74km = ncread(file, 'Energy deposition at 74 km');
  energy75km = ncread(file, 'Energy deposition at 75 km');
  energy76km = ncread(file, 'Energy deposition at 76 km');
  energy77km = ncread(file, 'Energy deposition at 77 km');
  energy78km = ncread(file, 'Energy deposition at 78 km');
  energy79km = ncread(file, 'Energy deposition at 79 km'); 
  energy80km = ncread(file, 'Energy deposition at 80 km');
   
datamatrix = [doy glat glong mlt cgmlat energy60km energy61km energy62km...
              energy63km energy64km energy65km energy66km energy67km...
              energy68km energy69km energy70km energy71km energy72km...
              energy73km energy74km energy75km energy76km energy77km...
              energy78km energy79km energy80km];
%--------------------------------------------------------------------------
% Sum over all heights, dz=1km = 1000m = 100000cm
%--------------------------------------------------------------------------            
totalenergy=zeros(length(doy),1);
for i=1:length(doy)
    totalenergy(i) = sum(datamatrix(i,6:26))*100000;
end 
          
Datamatrix = [doy glat glong mlt cgmlat totalenergy];    
          
for i=1:length(doy)
if glong(i)<7.5339 || glong(i)>357.5339
    Datamatrix(i,:)=Datamatrix(i,:);
else
    Datamatrix(i,:)=NaN;
end
end
for i=1:length(doy)
if  glat(i)>-77.0019 && glat(i)<-67.0019
    Datamatrix(i,:)=Datamatrix(i,:);
else 
    Datamatrix(i,:)=NaN;
end
end
%Remove all entries except those within designated glong and glat and store
Data2=Datamatrix(~isnan(Datamatrix(:,1)),:);

%--------------------------------------------------------------------------
% Satellite 3
%--------------------------------------------------------------------------
file='LossConeEnergyDeposition_south2008_1-366_N18_1MeV_1.04step_Filter300.nc';

doy = ncread(file, 'DOY'); %date of year
glat = ncread(file, 'Geographic latitude'); 
glong = ncread(file, 'Geographic longitude'); 
mlt = ncread(file,'Magnetic local time'); 
cgmlat = ncread(file,'Corrected geomagnetic latitude'); 

energy60km = ncread(file, 'Energy deposition at 60 km');
  energy61km = ncread(file, 'Energy deposition at 61 km');
  energy62km = ncread(file, 'Energy deposition at 62 km');
  energy63km = ncread(file, 'Energy deposition at 63 km');
  energy64km = ncread(file, 'Energy deposition at 64 km');
  energy65km = ncread(file, 'Energy deposition at 65 km');
  energy66km = ncread(file, 'Energy deposition at 66 km');
  energy67km = ncread(file, 'Energy deposition at 67 km');
  energy68km = ncread(file, 'Energy deposition at 68 km');
  energy69km = ncread(file, 'Energy deposition at 69 km'); 
  energy70km = ncread(file, 'Energy deposition at 70 km');
  energy71km = ncread(file, 'Energy deposition at 71 km');
  energy72km = ncread(file, 'Energy deposition at 72 km');
  energy73km = ncread(file, 'Energy deposition at 73 km');
  energy74km = ncread(file, 'Energy deposition at 74 km');
  energy75km = ncread(file, 'Energy deposition at 75 km');
  energy76km = ncread(file, 'Energy deposition at 76 km');
  energy77km = ncread(file, 'Energy deposition at 77 km');
  energy78km = ncread(file, 'Energy deposition at 78 km');
  energy79km = ncread(file, 'Energy deposition at 79 km'); 
  energy80km = ncread(file, 'Energy deposition at 80 km');
   
datamatrix = [doy glat glong mlt cgmlat energy60km energy61km energy62km...
              energy63km energy64km energy65km energy66km energy67km...
              energy68km energy69km energy70km energy71km energy72km...
              energy73km energy74km energy75km energy76km energy77km...
              energy78km energy79km energy80km];
%--------------------------------------------------------------------------
% Sum over all heights, dz=1km = 1000m = 100000cm
%--------------------------------------------------------------------------  
totalenergy=zeros(length(doy),1);
for i=1:length(doy)
    totalenergy(i) = sum(datamatrix(i,6:26))*100000;
end 
          
Datamatrix = [doy glat glong mlt cgmlat totalenergy];    
          
%--------------------------------------------------------------------------
% Coordinates for Troll: lat=-72.0019 long=2.5339, box = +/- 5 deg
%--------------------------------------------------------------------------

for i=1:length(doy)
if glong(i)<7.5339 || glong(i)>357.5339
    Datamatrix(i,:)=Datamatrix(i,:);
else
    Datamatrix(i,:)=NaN;
end
end
for i=1:length(doy)
if  glat(i)>-77.0019 && glat(i)<-67.0019
    Datamatrix(i,:)=Datamatrix(i,:);
else 
    Datamatrix(i,:)=NaN;
end
end

%Remove all entries except those within designated glong and glat and store
Data3=Datamatrix(~isnan(Datamatrix(:,1)),:);

%--------------------------------------------------------------------------
% Satellite 4
%--------------------------------------------------------------------------
file='LossConeEnergyDeposition_south2008_1-366_M02_1MeV_1.04step_Filter300.nc';

doy = ncread(file, 'DOY'); %date of year
glat = ncread(file, 'Geographic latitude'); 
glong = ncread(file, 'Geographic longitude'); 
mlt = ncread(file,'Magnetic local time'); 
cgmlat = ncread(file,'Corrected geomagnetic latitude'); 
sat = ncread(file,'Satellite');

energy60km = ncread(file, 'Energy deposition at 60 km');
  energy61km = ncread(file, 'Energy deposition at 61 km');
  energy62km = ncread(file, 'Energy deposition at 62 km');
  energy63km = ncread(file, 'Energy deposition at 63 km');
  energy64km = ncread(file, 'Energy deposition at 64 km');
  energy65km = ncread(file, 'Energy deposition at 65 km');
  energy66km = ncread(file, 'Energy deposition at 66 km');
  energy67km = ncread(file, 'Energy deposition at 67 km');
  energy68km = ncread(file, 'Energy deposition at 68 km');
  energy69km = ncread(file, 'Energy deposition at 69 km'); 
  energy70km = ncread(file, 'Energy deposition at 70 km');
  energy71km = ncread(file, 'Energy deposition at 71 km');
  energy72km = ncread(file, 'Energy deposition at 72 km');
  energy73km = ncread(file, 'Energy deposition at 73 km');
  energy74km = ncread(file, 'Energy deposition at 74 km');
  energy75km = ncread(file, 'Energy deposition at 75 km');
  energy76km = ncread(file, 'Energy deposition at 76 km');
  energy77km = ncread(file, 'Energy deposition at 77 km');
  energy78km = ncread(file, 'Energy deposition at 78 km');
  energy79km = ncread(file, 'Energy deposition at 79 km'); 
  energy80km = ncread(file, 'Energy deposition at 80 km');

datamatrix = [doy glat glong mlt cgmlat energy60km energy61km energy62km...
              energy63km energy64km energy65km energy66km energy67km...
              energy68km energy69km energy70km energy71km energy72km...
              energy73km energy74km energy75km energy76km energy77km...
              energy78km energy79km energy80km];
%--------------------------------------------------------------------------
% Sum over all heights, dz=1km = 1000m = 100000cm to get the column
%--------------------------------------------------------------------------  
totalenergy=zeros(length(doy),1);
for i=1:length(doy)
    totalenergy(i) = sum(datamatrix(i,6:26))*100000;
end 
%Now the energy is in keV/cm^2 s          
Datamatrix = [doy glat glong mlt cgmlat totalenergy];    

%--------------------------------------------------------------------------
% Coordinates for Troll: lat=-72.0019 long=2.5339, box = +/- 5 deg
%--------------------------------------------------------------------------

for i=1:length(doy)
if glong(i)<7.5339 || glong(i)>357.5339
    Datamatrix(i,:)=Datamatrix(i,:);
else
    Datamatrix(i,:)=NaN;
end
end
for i=1:length(doy)
if  glat(i)>-77.0019 && glat(i)<-67.0019
    Datamatrix(i,:)=Datamatrix(i,:);
else 
    Datamatrix(i,:)=NaN;
end
end

%Remove all entries except those within designated glong and glat and store
Data4=Datamatrix(~isnan(Datamatrix(:,1)),:);

%--------------------------------------------------------------------------
% Combine all satellite data and sort after dates
%--------------------------------------------------------------------------
 Totaldata = [Data1;Data2;Data3;Data4];
 Totaldata = sortrows(Totaldata,1); 
 
 doy=Totaldata(:,1); % This is the time-index, where 1.[number] represent
                     % a time point during day 1, and so on
 Values = Totaldata(:,6); % Precipitation values in keV/cm^2 s 
 
 % Creates a list over how many entries there are during each day
 count = 1;
 length_matrix=zeros(366,1);
 for i=1:366
 length_matrix(i) = length(Values(doy>=i & doy<i+1));
 end
 %-------------------------------------------------------------------------
 % Find mean values for each day, based on number of entries each day
 %-------------------------------------------------------------------------
 meanval = zeros(366,1);  % Preallocate vector for the mean precipitation
for i=1:365
    if length_matrix(i)==0
        meanval(i) = NaN;
    else
        meanval(i)=mean(Values(count:count+length_matrix(i)));
        count = count + length_matrix(i);
        
    end
end

%--------------------------------------------------------------------------
% Conversions of units
%--------------------------------------------------------------------------
  kev2mev  = 1.0e-3;      
  sec2day= 24.0*3600.0;   % Number of seconds in a day
  kev2ions = 1/(35.0e-3); % 35 eV/ionization
  time = 1:366;           

meanMeVprcm2s = [time',meanval*kev2mev];
meanMeVprcm2 = [time',meanval*sec2day*kev2mev];
ionsprcm2 = [time',meanval*sec2day*kev2ions];
% Plot data
figure(1)
subplot(2,2,1)
    plot(meanMeVprcm2s(:,2))
    title('Mean values in MeV/cm2 s')
subplot(2,2,2)
    plot(meanMeVprcm2(:,2))
    title('Mean values in MeV/cm2')
subplot(2,2,3)
    plot(ionsprcm2(:,2))
    title('Ions per cm2')
subplot(2,2,4)
    plot(meanval)
    title('Mean values in KeV/cm2 s')

figure(2)
plot(time',meanMeVprcm2)
title('Daily average precipitation for 60-80 km column in MeV/cm^2')
xlabel('DOY')
ylabel('MeV/cm^2')
figure(3)
plot(time',ionsprcm2(:,2))
title('MEP as ions per square centimeter')
xlabel('DOY')
ylabel('Ions per cm^2')

MEP = meanMeVprcm2;
save('MEPmean','MEP') %Save MEP values for later use
